"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserialize = deserialize;
const decorator_1 = require("../decorator");
const utils_1 = require("../utils");
const impl_1 = require("./impl");
function deserialize(constructor) {
    let Deserializable = class Deserializable extends constructor {
        static deserialize(deserializer) {
            return (0, impl_1.deserializeWith)(deserializer, this, (0, decorator_1.getMetadata)(this));
        }
    };
    Object.defineProperty(Deserializable, "name", {
        enumerable: true,
        configurable: true,
        writable: true,
        value: constructor.name
    });
    Deserializable = __decorate([
        (0, utils_1.staticImplements)()
    ], Deserializable);
    // @ts-ignore
    Deserializable[decorator_1.Serde] = constructor[decorator_1.Serde];
    return Deserializable;
}
